*! version 1.0 - pbe - 10/15/10
program regvalidate
version 11.0

  syntax [, reps(integer 50) seed(string)]
  tempvar fit so order
  tempname train test one mtr mte diff m1
    if "`e(cmd)'"~="regress" & "`e(cmd)'"~="anova" {
    display as err "regress command not found"
    exit
  }
  if "`seed'"!="" {
    set seed `seed'
  }
  estimates store `m1'
  gen `so' = _n
  local bign = e(N) 
  local smn = int(`bign'/2)
  local smn1 = `smn' + 1  
  local cmd = e(cmdline)
  local depvar = e(depvar)
  local r2 = e(r2)
  local rssn = e(rss)/e(N)
  quietly predict double `fit'
  quietly regress `depvar' `fit'
  local slope = _b[`fit']
  local cons  = _b[_cons]
  quietly gen `order' = .
  
  matrix `train' = J(`reps',4,.)
  matrix `test'  = J(`reps',4,.) 
  matrix `one'   = J(1,`reps',1)
  drop `fit'
  
  forvalues i=1/`reps' {
    quietly replace `order' = runiform()
    sort `order'
    quietly `cmd' in 1/`smn'
    quietly predict double `fit'
    quietly regress `depvar' `fit' in 1/`smn'
    matrix `train'[`i',1] = e(r2)
    matrix `train'[`i',2] = e(rss)/e(N)
    matrix `train'[`i',3] = _b[`fit']
    matrix `train'[`i',4] = _b[_cons]
    quietly regress `depvar' `fit' in `smn1'/l
    matrix `test'[`i',1]  = e(r2)
    matrix `test'[`i',2]  = e(rss)/e(N)
    matrix `test'[`i',3]  = _b[`fit']
    matrix `test'[`i',4]  = _b[_cons]
    drop `fit'
  }
  
  matrix `mtr'  = `one'*`train'*1/`reps'
  matrix `mte'  = `one'*`test'*1/`reps'
  matrix `diff' = `mtr'-`mte'
 
* debug code  
*  mat list `train'
*  mat list `mtr'
*  mat list `test'
*  mat list `mte'
*  mat lis `diff'
  
  display
  display as txt "original sample size = " as res `bign'  as txt "   reps = " as res `reps'
  display as txt "regression model: " as res "`cmd'"
  display
  display as txt "         " _skip(8) "orig"_skip(10) "train"_skip(9) "test" ///
                 _skip(10) "diff" _skip(10) "orig adj" 
  display as txt "R-squared" _skip(2) as res %12.4f `r2' _skip(2)  %12.4f  `mtr'[1,1] _skip(2)  %12.4f  `mte'[1,1] ///
          _skip(2)  %12.4f  `diff'[1,1] _skip(2)  %12.4f  `r2'-`mtr'[1,1]+`mte'[1,1]
  display as txt "rss/n    " _skip(2) as res %12.4f `rssn' _skip(2) %12.4f  `mtr'[1,2] _skip(2) %12.4f  `mte'[1,2] ///
          _skip(2) %12.4f  `diff'[1,2] _skip(2) %12.4f  `rssn'-`mtr'[1,2]+`mte'[1,2]
  display as txt "fit slope" _skip(2) as res  %12.4f `slope' _skip(2)  %12.4f `mtr'[1,3] _skip(2)  %12.4f `mte'[1,3] ///
          _skip(2)  %12.4f `diff'[1,3] _skip(2)  %12.4f `slope'-`mtr'[1,3]+`mte'[1,3]
  display as txt "fit _cons" _skip(2) as res  %12.4f `cons' _skip(2)  %12.4f `mtr'[1,4] _skip(2)  %12.4f `mte'[1,4] ///
          _skip(2)  %12.4f `diff'[1,4] _skip(2)  %12.4f `cons'-`mtr'[1,4]+`mte'[1,4]
  sort `so'
  quietly estimates restore `m1'
end
