{smcl}
{* *! version 1.0  15oct2010}{...}
help for {cmd:regvalidate}
{hline}

{title:Syntax}

{p 4 25 2}{cmd:regvalidate} [ , {cmd:reps(}{it:#}{cmd:)} {cmd:seed(}{it:#}{cmd:)} ]{p_end}

{pstd}{...}

{title:About regvalidate}

{pstd}{...}
{cmd:regvalidate} performs resampling validation of a regression model by repeatedly partioning
the data into training and test subsamples. {cmd:regvalidate} is a post estimation command
requiring that {cmd:regress} be run prior to running {cmd:regvalidate}.{p_end}

{pstd}Note: {cmd:regvalidate} does not allow {cmd:if} or {cmd:in} so all subsetting must be done
prior to running the regression model. {p_end}

{synoptset 24 tabbed}{...}
{synopthdr}
{synoptline}
{synopt :{opt reps(#)}}number of replications (default = 50){p_end}
{synopt :{opt seed(#)}}set random seed to #{p_end}

{title:Explanation of output}

orig      - values computed on the original sample          
train     - values computed on the training sample        
test      - values computed on the test sample          
diff      - diff = train - test          
orig adj  - orig adj = orig - train + test
rss/n     - MSE using n in denominator
fit slope - slope of model regressing dv on fitted values
fit _cons - _cons of model regressing dv on fitted values


{title:Examples}

{cmd:. use http://www.ats.ucla.edu/stat/data/hsbdemo, clear}
{cmd:. regress write read i.female}
{cmd:. regvalidate, reps(200)} 
{cmd:. regvalidate, reps(200) seed(987654321)}                   

{p2colreset}{...}

{title:Acknowledgements}

Inspired by the R function, validate.ols, written by Frank Harrell, Department of Biostatistics, 
Vanderbilt University.

{title:Author}

{p 4 4 2}Philip B. Ender{break}
UCLA Statistical Consulting Group{break}
ender@ucla.edu 

{p2colreset}{...}

